' SocketTools 10 ActiveX Edition
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'

Option Explicit

Dim objSsh
Dim objArgs
Dim nArg
Dim strLicenseKey
Dim strCommand
Dim strBuffer
Dim bResult
Dim nError

'
' Create an instance of the control
'
Set objSsh = WScript.CreateObject("SocketTools.SshClient.10")

'
' Initialize the object using the specified runtime license key;
' if the key is not specified, the development license will be used
'
strLicenseKey = "" ' Should be set to the runtime license key
nError = objSsh.Initialize(strLicenseKey) 
If nError <> 0 Then
    WScript.Echo "Unable to initialize SocketTools component"
    WScript.Quit(1)
End If

'
' Process command line arguments
'
Set objArgs = WScript.Arguments
If objArgs.Count < 5 Then
    WScript.StdErr.WriteLine "Usage: " & WScript.ScriptName & " hostname port username password command"
    WScript.Quit(1)
End If

objSsh.HostName = objArgs(0)
objSsh.RemotePort = objArgs(1)
objSsh.UserName = objArgs(2)
objSsh.Password = objArgs(3)

strCommand = objArgs(4)
For nArg = 5 To objArgs.Count - 1
	strCommand = strCommand + " " + objArgs(nArg)
Next

objSsh.Command = strCommand

nError = objSsh.Connect()
If nError > 0 Then
    WScript.StdErr.WriteLine "Error " & objSsh.LastError & ": " & objSsh.LastErrorString
    WScript.Quit(1)
End If

Do
	bResult = objSsh.ReadLine(strBuffer)
	If bResult Then WScript.Echo strBuffer
Loop Until bResult = False

objSSh.Disconnect
objSsh.Uninitialize
