VERSION 5.00
Object = "{5278BD09-BDDB-4941-A4E7-BC06219CC79A}#1.0#0"; "cswskx10.ocx"
Begin VB.Form formMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Asynchronous Socket I/O Test"
   ClientHeight    =   2430
   ClientLeft      =   3150
   ClientTop       =   2775
   ClientWidth     =   4725
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2430
   ScaleWidth      =   4725
   Begin SocketWrenchCtl.SocketWrench SocketWrench1 
      Left            =   240
      Top             =   1440
      _cx             =   741
      _cy             =   741
   End
   Begin VB.TextBox editBufferSize 
      Height          =   315
      Left            =   720
      TabIndex        =   5
      Text            =   "4096"
      Top             =   600
      Width           =   735
   End
   Begin VB.TextBox editBufferTotal 
      Height          =   315
      Left            =   2280
      TabIndex        =   7
      Text            =   "100"
      Top             =   600
      Width           =   1095
   End
   Begin VB.TextBox editRemotePort 
      Height          =   315
      Left            =   4020
      TabIndex        =   3
      Text            =   "7"
      Top             =   180
      Width           =   495
   End
   Begin VB.TextBox editHostName 
      Height          =   315
      Left            =   720
      TabIndex        =   1
      Top             =   180
      Width           =   2655
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "Test"
      Default         =   -1  'True
      Height          =   435
      Left            =   1740
      TabIndex        =   8
      Top             =   1500
      Width           =   1215
   End
   Begin VB.Label staticBufferSize 
      AutoSize        =   -1  'True
      Caption         =   "Buffer:"
      Height          =   195
      Left            =   120
      TabIndex        =   4
      Top             =   660
      Width           =   465
   End
   Begin VB.Label staticBytes 
      AutoSize        =   -1  'True
      Caption         =   "KBytes:"
      Height          =   195
      Left            =   1620
      TabIndex        =   6
      Top             =   660
      Width           =   540
   End
   Begin VB.Label staticRemotePort 
      AutoSize        =   -1  'True
      Caption         =   "Port:"
      Height          =   195
      Left            =   3540
      TabIndex        =   2
      Top             =   240
      Width           =   330
   End
   Begin VB.Label staticHostName 
      AutoSize        =   -1  'True
      Caption         =   "Host:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   375
   End
   Begin VB.Label labelStatus 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   0
      TabIndex        =   9
      Top             =   2100
      Width           =   4695
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketWrench 10.0
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Dim g_strBuffer As String    ' Global data I/O buffer
Dim g_nBufferSize As Long    ' Size of the I/O buffer
Dim g_nBufferTotal As Long   ' Total number of bytes to read/write
Dim g_nBytesIn As Long       ' Number of bytes read
Dim g_nBytesOut As Long      ' Number of bytes written
Dim g_nTimerStart As Long    ' Timer start value in ticks
Dim g_nTimerEnd As Long      ' Timer end value in ticks

'
' Return the current tick count, which is the number of milliseconds
' that the system has been running; this function has a granularity
' of approximately 10 milliseconds
'
Private Declare Function GetTickCount Lib "kernel32" () As Long

Sub UpdateStatus()
    Dim dblTimeElapsed As Double
    Dim dblTransferRate As Double
    
    '
    ' Update the status label control with the elapsed time
    ' and the transfer rate
    '
    dblTimeElapsed = CDbl(g_nTimerEnd - g_nTimerStart) / 1000#
    dblTransferRate = (CDbl(g_nBytesIn + g_nBytesOut) / 1024#) / dblTimeElapsed
    labelStatus.Caption = Format(dblTimeElapsed, "#.##") & " seconds, " & Format(dblTransferRate, "#.##") & " kb/s"
    
    cmdAction.Enabled = True
End Sub

Private Sub cmdAction_Click()
    Dim nError As Long
    Dim nIndex As Long, nValue As Long
    
    '
    ' Intialize the globals
    '
    g_nBufferSize = Val(editBufferSize.Text)
    g_nBufferTotal = CLng(Trim(editBufferTotal.Text)) * 1024
    g_strBuffer = ""
    g_nBytesIn = 0
    g_nBytesOut = 0
    g_nTimerStart = 0
    g_nTimerEnd = 0
    
    '
    ' Validate the values specified by the user
    '
    If g_nBufferSize < 32 Or g_nBufferSize > 16384 Then
        MsgBox "An invalid buffer size was specified", vbExclamation
        editBufferSize.SetFocus
        Exit Sub
    End If
    
    If g_nBufferTotal < 1 Then
        MsgBox "A minimum value of 1K bytes must be specified", vbInformation
        editBufferTotal.SetFocus
        Exit Sub
    End If
    
    If Len(Trim(editHostName.Text)) = 0 Then
        MsgBox "No server hostname was specified", vbExclamation
        editHostName.SetFocus
        Exit Sub
    End If
    
    If Val(Trim(editRemotePort.Text)) = 0 Then
        MsgBox "An invalid port number was specified", vbExclamation
        editRemotePort.SetFocus
        Exit Sub
    End If
    
    '
    ' Create a buffer that contains random bytes; note
    ' that we do this in order to create a more 'real world'
    ' test; using a simple repeating pattern that is easily
    ' compressed will skew the results on dial-up lines
    '
    Randomize
    For nIndex = 0 To g_nBufferSize - 1
        ' nValue = CLng(254 * Rnd + 1)
        nValue = 65
        g_strBuffer = g_strBuffer + Chr$(nValue)
    Next nIndex
    
    '
    ' Initialize the socket control
    '
    SocketWrench1.AutoResolve = False
    SocketWrench1.Blocking = False
    SocketWrench1.Timeout = 10 ' Seconds
    
    '
    ' Establish the connection; note that since this is an
    ' asynchronous socket, we are not actually connected to
    ' the server until the Connect event fires
    '
    If SocketWrench1.Connect(Trim(editHostName.Text), Val(Trim(editRemotePort))) <> 0 Then
        labelStatus.Caption = "Unable to connect to remote host (error " & SocketWrench1.LastError & ")"
        Exit Sub
    End If
        
    labelStatus.Caption = ""
    cmdAction.Enabled = False
        
End Sub

Private Sub editBufferSize_GotFocus()
    editBufferSize.SelStart = 0
    editBufferSize.SelLength = Len(editBufferSize.Text)
End Sub

Private Sub editBufferTotal_GotFocus()
    editBufferTotal.SelStart = 0
    editBufferTotal.SelLength = Len(editBufferTotal.Text)
End Sub

Private Sub editHostName_GotFocus()
    editHostName.SelStart = 0
    editHostName.SelLength = Len(editHostName.Text)
End Sub

Private Sub editRemotePort_GotFocus()
    editRemotePort.SelStart = 0
    editRemotePort.SelLength = Len(editRemotePort.Text)
End Sub

Private Sub SocketWrench1_OnConnect()
    '
    ' The connection to the server has completed
    '
    g_nTimerStart = GetTickCount()
End Sub

Private Sub SocketWrench1_OnDisconnect()
    '
    ' The remote host has closed the connection for some reason;
    ' disconnect and update the the status label
    '
    Dim nError As Long
    
    nError = SocketWrench1.Disconnect
    If (nError <> 0) Then
        MsgBox "Unable to disconnect.  Error " & nError
    End If
    
    labelStatus.Caption = "Remote host closed connection"
    cmdAction.Enabled = True
End Sub

Private Sub SocketWrench1_OnRead()
    Dim strBuffer As String
    Dim nRead As Long
    
    '
    ' This event fires when there is data available to be
    ' read. This event will fire after the first block of
    ' data has been written and returned by the echo server.
    ' We read all of the available data until the Read method
    ' returns a value less than 1. A return value of 0 means
    ' that the socket is closed; a value of -1 indicates
    ' that there is no more data available to read at that
    ' time, and we should exit and wait for the Read event
    ' to fire again
    '
    Do While g_nBytesIn < g_nBufferTotal
        '
        ' Read up to g_nBufferSize bytes of data from the
        ' remote host
        '
        nRead = SocketWrench1.Read(strBuffer, g_nBufferSize)
        If nRead < 1 Then
            Exit Do
        Else
            g_nBytesIn = g_nBytesIn + nRead
            '
            ' If we have read all of the available data, then
            ' the test has completed; get the tick count,
            ' disconnect the socket and update the status label
            '
            If g_nBytesIn >= g_nBufferTotal Then
                g_nTimerEnd = GetTickCount()
                SocketWrench1.Disconnect
                UpdateStatus
                Exit Do
            End If
        End If
    Loop

End Sub

Private Sub SocketWrench1_OnWrite()
    Dim nWrite As Long
    
    '
    ' The Write event fires whenever data can be written
    ' to the socket. This event will fire immediately after
    ' the Connect event, which indicates that the socket is
    ' writable. If the socket's output buffer becomes full,
    ' the Write function will return -1, at which point we
    ' must stop writing until another Write event fires.
    '
    Do While g_nBytesOut < g_nBufferTotal
        nWrite = SocketWrench1.Write(g_strBuffer, g_nBufferSize)
        If nWrite = -1 Then
            Exit Do
        Else
            g_nBytesOut = g_nBytesOut + nWrite
            If g_nBytesOut >= g_nBufferTotal Then Exit Do
        End If
    Loop
End Sub


