Attribute VB_Name = "Constants"
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
'
' Note that this module is no longer needed with SocketTools 10.0,
' however it has been retained for compatibility with previous
' versions.
' 
'
Option Explicit

'
' RAS Control Connection States
'
Global Const RASCS_UNUSED = -1                ' The control is not in use
Global Const RASCS_OPENPORT = 0               ' The communications port is about to be opened
Global Const RASCS_PORTOPENED = 1             ' The communications port has been opened
Global Const RASCS_CONNECTDEVICE = 2          ' A device is about to be connected
Global Const RASCS_DEVICECONNECTED = 3        ' A device has been connected successfully
Global Const RASCS_ALLDEVICESCONNECTED = 4    ' All devices have been connected, physical link established
Global Const RASCS_AUTHENTICATE = 5           ' The authentication phase is starting
Global Const RASCS_AUTHNOTIFY = 6             ' An authentication event has occurred
Global Const RASCS_AUTHRETRY = 7              ' The client has requested another validation attempt
Global Const RASCS_AUTHCALLBACK = 8           ' The remote server has requested a callback number
Global Const RASCS_AUTHCHANGEPASSWORD = 9     ' The client has requested to change the password
Global Const RASCS_AUTHPROJECT = 10           ' The projection phase is starting
Global Const RASCS_AUTHLINKSPEED = 11         ' The link speed calculation phase is starting
Global Const RASCS_AUTHACK = 12               ' The authentication request has been acknowledged
Global Const RASCS_REAUTHENTICATE = 13        ' Re-authentication after a callback is starting
Global Const RASCS_AUTHENTICATED = 14         ' The client has successfully completed authentication
Global Const RASCS_PREPAREFORCALLBACK = 15    ' The link is about to disconnect in preperation for a callback
Global Const RASCS_WAITFORMODEMRESET = 16     ' The client is waiting for the modem to reset
Global Const RASCS_WAITFORCALLBACK = 17       ' The client is waiting for an incoming callback
Global Const RASCS_PROJECTED = 18             ' The projection phase has completed
Global Const RASCS_CONNECTED = 8192           ' A successful connection has been established
Global Const RASCS_DISCONNECTED = 8193        ' The client has been disconnected or the connection attempt failed

'
' RAS Control Error Codes
'
' These error codes are returned by the LastError property and
' passed as an argument to the LastError event. These are the
' same codes returned by the RAS library, with 25000 added to the
' base value
'
Global Const ERROR_INVALID_PORT_HANDLE = 25601
Global Const ERROR_PORT_ALREADY_OPEN = 25602
Global Const ERROR_BUFFER_TOO_SMALL = 25603
Global Const ERROR_WRONG_INFO_SPECIFIED = 25604
Global Const ERROR_CANNOT_SET_PORT_INFO = 25605
Global Const ERROR_PORT_NOT_CONNECTED = 25606
Global Const ERROR_EVENT_INVALID = 25607
Global Const ERROR_DEVICE_DOES_NOT_EXIST = 25608
Global Const ERROR_DEVICETYPE_DOES_NOT_EXIST = 25609
Global Const ERROR_INVALID_BUFFER = 25610
Global Const ERROR_ROUTE_NOT_AVAILABLE = 25611
Global Const ERROR_ROUTE_NOT_ALLOCATED = 25612
Global Const ERROR_INVALID_COMPRESSION_SPECIFIED = 25613
Global Const ERROR_OUT_OF_BUFFERS = 25614
Global Const ERROR_PORT_NOT_FOUND = 25615
Global Const ERROR_ASYNC_REQUEST_PENDING = 25616
Global Const ERROR_ALREADY_DISCONNECTING = 25617
Global Const ERROR_PORT_NOT_OPEN = 25618
Global Const ERROR_PORT_DISCONNECTED = 25619
Global Const ERROR_NO_ENDPOINTS = 25620
Global Const ERROR_CANNOT_OPEN_PHONEBOOK = 25621
Global Const ERROR_CANNOT_LOAD_PHONEBOOK = 25622
Global Const ERROR_CANNOT_FIND_PHONEBOOK_ENTRY = 25623
Global Const ERROR_CANNOT_WRITE_PHONEBOOK = 25624
Global Const ERROR_CORRUPT_PHONEBOOK = 25625
Global Const ERROR_CANNOT_LOAD_STRING = 25626
Global Const ERROR_KEY_NOT_FOUND = 25627
Global Const ERROR_DISCONNECTION = 25628
Global Const ERROR_REMOTE_DISCONNECTION = 25629
Global Const ERROR_HARDWARE_FAILURE = 25630
Global Const ERROR_USER_DISCONNECTION = 25631
Global Const ERROR_INVALID_SIZE = 25632
Global Const ERROR_PORT_NOT_AVAILABLE = 25633
Global Const ERROR_CANNOT_PROJECT_CLIENT = 25634
Global Const ERROR_UNKNOWN = 25635
Global Const ERROR_WRONG_DEVICE_ATTACHED = 25636
Global Const ERROR_BAD_STRING = 25637
Global Const ERROR_REQUEST_TIMEOUT = 25638
Global Const ERROR_CANNOT_GET_LANA = 25639
Global Const ERROR_NETBIOS_ERROR = 25640
Global Const ERROR_SERVER_OUT_OF_RESOURCES = 25641
Global Const ERROR_NAME_EXISTS_ON_NET = 25642
Global Const ERROR_SERVER_GENERAL_NET_FAILURE = 25643
Global Const ERROR_AUTH_INTERNAL = 25645
Global Const ERROR_RESTRICTED_LOGON_HOURS = 25646
Global Const ERROR_ACCT_DISABLED = 25647
Global Const ERROR_PASSWD_EXPIRED = 25648
Global Const ERROR_NO_DIALIN_PERMISSION = 25649
Global Const ERROR_SERVER_NOT_RESPONDING = 25650
Global Const ERROR_FROM_DEVICE = 25651
Global Const ERROR_UNRECOGNIZED_RESPONSE = 25652
Global Const ERROR_MACRO_NOT_FOUND = 25653
Global Const ERROR_MACRO_NOT_DEFINED = 25654
Global Const ERROR_MESSAGE_MACRO_NOT_FOUND = 25655
Global Const ERROR_DEFAULTOFF_MACRO_NOT_FOUND = 25656
Global Const ERROR_FILE_COULD_NOT_BE_OPENED = 25657
Global Const ERROR_DEVICENAME_TOO_LONG = 25658
Global Const ERROR_DEVICENAME_NOT_FOUND = 25659
Global Const ERROR_NO_RESPONSES = 25660
Global Const ERROR_NO_COMMAND_FOUND = 25661
Global Const ERROR_WRONG_KEY_SPECIFIED = 25662
Global Const ERROR_UNKNOWN_DEVICE_TYPE = 25663
Global Const ERROR_ALLOCATING_MEMORY = 25664
Global Const ERROR_PORT_NOT_CONFIGURED = 25665
Global Const ERROR_DEVICE_NOT_READY = 25666
Global Const ERROR_READING_INI_FILE = 25667
Global Const ERROR_NO_CONNECTION = 25668
Global Const ERROR_BAD_USAGE_IN_INI_FILE = 25669
Global Const ERROR_READING_SECTIONNAME = 25670
Global Const ERROR_READING_DEVICETYPE = 25671
Global Const ERROR_READING_DEVICENAME = 25672
Global Const ERROR_READING_USAGE = 25673
Global Const ERROR_READING_MAXCONNECTBPS = 25674
Global Const ERROR_READING_MAXCARRIERBPS = 25675
Global Const ERROR_LINE_BUSY = 25676
Global Const ERROR_VOICE_ANSWER = 25677
Global Const ERROR_NO_ANSWER = 25678
Global Const ERROR_NO_CARRIER = 25679
Global Const ERROR_NO_DIALTONE = 25680
Global Const ERROR_IN_COMMAND = 25681
Global Const ERROR_WRITING_SECTIONNAME = 25682
Global Const ERROR_WRITING_DEVICETYPE = 25683
Global Const ERROR_WRITING_DEVICENAME = 25684
Global Const ERROR_WRITING_MAXCONNECTBPS = 25685
Global Const ERROR_WRITING_MAXCARRIERBPS = 25686
Global Const ERROR_WRITING_USAGE = 25687
Global Const ERROR_WRITING_DEFAULTOFF = 25688
Global Const ERROR_READING_DEFAULTOFF = 25689
Global Const ERROR_EMPTY_INI_FILE = 25690
Global Const ERROR_AUTHENTICATION_FAILURE = 25691
Global Const ERROR_PORT_OR_DEVICE = 25692
Global Const ERROR_NOT_BINARY_MACRO = 25693
Global Const ERROR_DCB_NOT_FOUND = 25694
Global Const ERROR_STATE_MACHINES_NOT_STARTED = 25695
Global Const ERROR_STATE_MACHINES_ALREADY_STARTED = 25696
Global Const ERROR_PARTIAL_RESPONSE_LOOPING = 25697
Global Const ERROR_UNKNOWN_RESPONSE_KEY = 25698
Global Const ERROR_RECV_BUF_FULL = 25699
Global Const ERROR_CMD_TOO_LONG = 25700
Global Const ERROR_UNSUPPORTED_BPS = 25701
Global Const ERROR_UNEXPECTED_RESPONSE = 25702
Global Const ERROR_INTERACTIVE_MODE = 25703
Global Const ERROR_BAD_CALLBACK_NUMBER = 25704
Global Const ERROR_INVALID_AUTH_STATE = 25705
Global Const ERROR_WRITING_INITBPS = 25706
Global Const ERROR_INVALID_WIN_HANDLE = 25707
Global Const ERROR_NO_PASSWORD = 25708
Global Const ERROR_NO_USERNAME = 25709
Global Const ERROR_CANNOT_START_STATE_MACHINE = 25710
Global Const ERROR_GETTING_COMMSTATE = 25711
Global Const ERROR_SETTING_COMMSTATE = 25712
Global Const ERROR_COMM_FUNCTION = 25713
Global Const ERROR_CONFIGURATION_PROBLEM = 25714
Global Const ERROR_X25_DIAGNOSTIC = 25715
Global Const ERROR_TOO_MANY_LINE_ERRORS = 25716
Global Const ERROR_OVERRUN = 25717
Global Const ERROR_ACCT_EXPIRED = 25718
Global Const ERROR_CHANGING_PASSWORD = 25719
Global Const ERROR_NO_ACTIVE_ISDN_LINES = 25720
Global Const ERROR_NO_ISDN_CHANNELS_AVAILABLE = 25721
