VERSION 5.00
Begin VB.Form formConnect 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Connect"
   ClientHeight    =   2325
   ClientLeft      =   6075
   ClientTop       =   4560
   ClientWidth     =   5565
   ControlBox      =   0   'False
   ForeColor       =   &H80000008&
   LinkTopic       =   "formConnect"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2325
   ScaleWidth      =   5565
   Begin VB.CheckBox chkSecure 
      Caption         =   "Secure "
      Height          =   255
      Left            =   2040
      TabIndex        =   9
      Top             =   1020
      Width           =   1035
   End
   Begin VB.CheckBox chkBlocking 
      Caption         =   "Blocking"
      Height          =   255
      Left            =   900
      TabIndex        =   8
      Top             =   1020
      Width           =   1035
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   435
      Left            =   2940
      MousePointer    =   1  'Arrow
      TabIndex        =   6
      Top             =   1680
      Width           =   1275
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "&Connect"
      Default         =   -1  'True
      Height          =   435
      Left            =   1320
      TabIndex        =   5
      Top             =   1680
      Width           =   1275
   End
   Begin VB.TextBox editTimeout 
      Height          =   315
      Left            =   4200
      TabIndex        =   4
      Text            =   "60"
      Top             =   600
      Width           =   615
   End
   Begin VB.ComboBox comboServiceName 
      Height          =   315
      Left            =   900
      Sorted          =   -1  'True
      TabIndex        =   2
      Top             =   600
      Width           =   2175
   End
   Begin VB.TextBox editHostName 
      Height          =   315
      Left            =   900
      TabIndex        =   0
      Text            =   "localhost"
      Top             =   180
      Width           =   3915
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "&Timeout:"
      Height          =   195
      Left            =   3360
      TabIndex        =   3
      Top             =   660
      Width           =   615
   End
   Begin VB.Label staticRemotePort 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "&Port:"
      Height          =   195
      Left            =   120
      TabIndex        =   1
      Top             =   660
      Width           =   330
   End
   Begin VB.Label staticHostName 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "&Server:"
      Height          =   195
      Left            =   120
      TabIndex        =   7
      Top             =   240
      Width           =   510
   End
End
Attribute VB_Name = "formConnect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketWrench 10.0
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Sub cmdCancel_Click()
    If formMain.socketClient.State = swStatusConnect Then
        '
        ' If the Cancel button is pressed during the connection
        ' process, then cancel the connection and return. This
        ' will cause the error swErrorOperationCanceled to be
        ' generated in thecmdConnect_Click event handler, which
        ' will in turn call the error handling routine
        '
        formMain.socketClient.Cancel
        Exit Sub
    End If
    
    Unload Me
End Sub

Private Sub cmdConnect_Click()
    Dim nError As Integer, strError As String
    
    cmdConnect.Enabled = False
    Me.MousePointer = vbHourglass
    
    formMain.socketClient.AutoResolve = False
    formMain.socketClient.RemoteService = Trim(comboServiceName.Text)

    If chkBlocking.Value = 0 Then
        formMain.socketClient.Blocking = False
    Else
        formMain.socketClient.Blocking = True
    End If

    If chkSecure.Value = 0 Then
        formMain.socketClient.Secure = False
    Else
        formMain.socketClient.Secure = True
    End If
    
    nError = formMain.socketClient.Connect(Trim(editHostName.Text), formMain.socketClient.RemotePort, swProtocolTcp, Val(editTimeout.Text) * 1000)
    
    If nError <> 0 Then
        '
        ' Explicitly disconnect (close) the socket that was created
        ' during the connection attempt; although this is not necessary
        ' in some cases, it is safe to do and ensures that the resources
        ' allocated by the control are always released
        '
        formMain.socketClient.Disconnect

        Select Case nError
        Case swErrorOperationCanceled:
            '
            ' This error is generated if the user has pressed the Cancel
            ' button and canceled the connection attempt; disconnect (close)
            ' the socket to release any resources allocated for it, and
            ' unload the form
            '
            Unload Me
            Exit Sub

        Case swErrorConnectionRefused:
            '
            ' The remote host has refused the connection; this typically
            ' means that there is no service listening on the specified
            ' port on that system
            '
            strError = "The remote host does not have an active service on the specified port"

        Case swErrorOperationTimeout:
            '
            ' The client has timed-out attempting to connect to the
            ' specified address and port number
            '
            strError = "Unable to establish a connection with the remote host"

        Case swErrorInvalidHostName:
            '
            ' The client was unable to resolve the specified hostname into
            ' an IP address; this typically indicates an invalid hostnane,
            ' or the inability to query a nameserver (ie: the client is
            ' using a dial-up networking connection and is offline)
            '
            strError = "The server name is invalid, or could not be resolved" + Chr(13) + Chr(10)
            strError = strError + "Please check the server name and try again"
    
        Case Else
            '
            ' An unexpected error has occurred
            '
            strError = "An unexpected error has occurred (Error " & nError & ")"
        End Select
    
        Me.MousePointer = vbDefault
        MsgBox strError, vbOK + vbExclamation, "Connection Failed"

        editHostName.SetFocus
        Exit Sub
    End If

    Me.MousePointer = vbDefault
    Unload Me
End Sub

Private Sub comboServiceName_Change()
    UpdateForm
End Sub

Private Sub editHostName_Change()
    UpdateForm
End Sub

Private Sub editHostName_GotFocus()
    editHostName.SelStart = 0
    editHostName.SelLength = Len(editHostName.Text)
End Sub

Private Sub editTimeout_Change()
    UpdateForm
End Sub

Private Sub editTimeout_GotFocus()
    editTimeout.SelStart = 0
    editTimeout.SelLength = Len(editTimeout.Text)
End Sub

Private Sub Form_Load()
    
    comboServiceName.AddItem "chargen"
    comboServiceName.AddItem "discard"
    comboServiceName.AddItem "echo"
    comboServiceName.Text = "echo"

    UpdateForm
End Sub

Private Sub UpdateForm()
    Dim bEnable As Integer

    bEnable = True
    If Len(Trim(editHostName.Text)) = 0 Then bEnable = False
    If Len(Trim(comboServiceName.Text)) = 0 Then bEnable = False
    If Val(Trim(editTimeout.Text)) = 0 Then bEnable = False

    cmdConnect.Enabled = bEnable
End Sub

