VERSION 5.00
Object = "{8A718D2D-8AF7-4B72-A074-093208112A54}#1.0#0"; "cswsvx10.ocx"
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Echo Server Example"
   ClientHeight    =   4920
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   8040
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4920
   ScaleWidth      =   8040
   StartUpPosition =   2  'CenterScreen
   Begin InternetServerCtl.InternetServer EchoServer 
      Left            =   6600
      Top             =   3960
      _cx             =   741
      _cy             =   741
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Close"
      Height          =   375
      Left            =   6600
      TabIndex        =   11
      Top             =   1680
      Width           =   1215
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Restart"
      Enabled         =   0   'False
      Height          =   375
      Left            =   6600
      TabIndex        =   10
      Top             =   1186
      Width           =   1215
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Suspend"
      Enabled         =   0   'False
      Height          =   375
      Left            =   6600
      TabIndex        =   9
      Top             =   693
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Start"
      Default         =   -1  'True
      Height          =   375
      Left            =   6600
      TabIndex        =   8
      Top             =   200
      Width           =   1215
   End
   Begin VB.ListBox List1 
      Height          =   3765
      Left            =   240
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   680
      Width           =   6135
   End
   Begin VB.TextBox Text3 
      Height          =   315
      Left            =   5520
      TabIndex        =   5
      Text            =   "100"
      Top             =   200
      Width           =   800
   End
   Begin VB.TextBox Text2 
      Height          =   315
      Left            =   3840
      TabIndex        =   3
      Text            =   "7000"
      Top             =   200
      Width           =   800
   End
   Begin VB.TextBox Text1 
      Height          =   315
      Left            =   840
      TabIndex        =   1
      Text            =   "127.0.0.1"
      Top             =   200
      Width           =   2295
   End
   Begin VB.Label Status1 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   0
      TabIndex        =   7
      Top             =   4600
      Width           =   8050
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Clients:"
      Height          =   195
      Left            =   4920
      TabIndex        =   4
      Top             =   240
      Width           =   510
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Port:"
      Height          =   195
      Left            =   3360
      TabIndex        =   2
      Top             =   240
      Width           =   330
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Server:"
      Height          =   195
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   510
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketWrench 10.0
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Sub UpdateForm(ByVal bEnable As Boolean)
    If EchoServer.IsActive Then
        Command1.Caption = "Stop"
        Command1.Enabled = bEnable
        Command2.Enabled = bEnable
        Command2.Caption = IIf(EchoServer.IsListening, "Suspend", "Resume")
        Command3.Enabled = IIf(EchoServer.ClientCount > 0, bEnable, False)
    Else
        Command1.Caption = "Start"
        Command1.Enabled = bEnable
        Command2.Caption = "Suspend"
        Command2.Enabled = False
        Command3.Enabled = False
    End If

    Status1.Caption = "There are " & EchoServer.ClientCount & " client(s) connected to the server"
End Sub

Private Sub AddListItem(ByVal strText As String)
    List1.AddItem strText
    List1.ListIndex = List1.ListCount - 1
    List1.Selected(List1.ListIndex) = False
End Sub

Private Sub Form_Load()
    UpdateForm True
End Sub

Private Sub Command1_Click()
    Dim strLocalAddress As String
    Dim nLocalPort As Long
    Dim nMaxClients As Long
    Dim nError As Long
    
    If Not EchoServer.IsActive Then
        strLocalAddress = Trim(Text1.Text)
        nLocalPort = Val(Text2.Text)
        nMaxClients = Val(Text3.Text)
        
        UpdateForm False
        
        nError = EchoServer.Start(strLocalAddress, nLocalPort, 5, nMaxClients)
        
        If nError > 0 Then
            MsgBox EchoServer.LastErrorString, vbExclamation
        End If
    Else
        UpdateForm False
        
        nError = EchoServer.Stop()
        
        If nError > 0 Then
            Exit Sub
        End If
    End If

    UpdateForm True
End Sub

Private Sub Command2_Click()
    Dim nError As Long
    
    UpdateForm False
    
    If EchoServer.IsListening Then
        nError = EchoServer.Suspend(swSuspendReject)
        
        If nError = 0 Then
            AddListItem "Server suspended accepting new client connections"
        Else
            MsgBox EchoServer.LastErrorString, vbExclamation
        End If
    Else
        nError = EchoServer.Resume()
            
        If nError = 0 Then
            AddListItem "Server resumed accepting new client connections"
        Else
            MsgBox EchoServer.LastErrorString, vbExclamation
        End If
    End If
    
    UpdateForm True
End Sub

Private Sub Command3_Click()
    Dim nError As Long
    
    UpdateForm False
    
    nError = EchoServer.Restart()
    
    If nError = 0 Then
        AddListItem "Restarted server, accepting client connections"
    Else
        MsgBox EchoServer.LastErrorString, vbExclamation
    End If
    
    UpdateForm True
End Sub

Private Sub Command4_Click()
    If EchoServer.IsActive Then
        UpdateForm False
        EchoServer.Stop
    End If

    Unload Me
End Sub

Private Sub EchoServer_OnStart()
    AddListItem "Server accepting connections on " & EchoServer.ServerAddress & ":" & EchoServer.ServerPort
    UpdateForm True
End Sub

Private Sub EchoServer_OnAccept(ByVal Handle As Variant)
    AddListItem "Server accepting client connection from " & EchoServer.ClientAddress & ":" & EchoServer.ClientPort
End Sub

Private Sub EchoServer_OnConnect(ByVal Handle As Variant)
    AddListItem "Client " & EchoServer.ClientId & " connected to server from " & EchoServer.ClientAddress & ":" & EchoServer.ClientPort
    UpdateForm True
End Sub

Private Sub EchoServer_OnDisconnect(ByVal Handle As Variant)
    AddListItem "Client " & EchoServer.ClientId & " disconnected from server"
    UpdateForm True
End Sub

Private Sub EchoServer_OnError(ByVal Handle As Variant, ByVal ErrorCode As Variant, ByVal Description As Variant)
    AddListItem "Error " & ErrorCode & ": " & Description
End Sub

Private Sub EchoServer_OnIdle()
    AddListItem "Server is idle, all clients disconnected"
End Sub

Private Sub EchoServer_OnRead(ByVal Handle As Variant)
    Dim ioBuffer(1024) As Byte
    Dim nBytesRead As Long
    Dim nBytesWritten As Long
    
    nBytesRead = EchoServer.Read(Handle, ioBuffer, 1024)
    If nBytesRead > 0 Then
        nBytesWritten = EchoServer.Write(Handle, ioBuffer, nBytesRead)
    End If
End Sub

Private Sub EchoServer_OnStop()
    AddListItem "Server stopped accepting connections, all clients terminated"
    UpdateForm True
End Sub

