VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{7EE1079B-E89E-46F4-B426-EAFDF25D31D7}#1.0#0"; "csncdx10.ocx"
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools File Encoder Example"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5730
   Icon            =   "Encode.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   5730
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdDecode 
      Caption         =   "Decode"
      Height          =   435
      Left            =   2966
      TabIndex        =   7
      Top             =   2160
      Width           =   1275
   End
   Begin VB.CommandButton cmdEncode 
      Caption         =   "Encode"
      Height          =   435
      Left            =   1489
      TabIndex        =   6
      Top             =   2160
      Width           =   1275
   End
   Begin VB.CheckBox chkCompressed 
      Caption         =   "Compress / Expand File"
      Height          =   315
      Left            =   960
      TabIndex        =   5
      ToolTipText     =   "Automatically compress an encoded file or expand a decoded file"
      Top             =   1020
      Width           =   3555
   End
   Begin VB.ComboBox comboEncoding 
      Height          =   315
      Left            =   960
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   660
      Width           =   3555
   End
   Begin MSComDlg.CommonDialog cmnDialog 
      Left            =   5100
      Top             =   240
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "..."
      Height          =   315
      Left            =   4560
      TabIndex        =   2
      ToolTipText     =   "Browse for a file to encode or decode"
      Top             =   240
      Width           =   315
   End
   Begin VB.TextBox editFileName 
      Height          =   315
      Left            =   960
      TabIndex        =   1
      Top             =   240
      Width           =   3555
   End
   Begin FileEncoderCtl.FileEncoder FileEncoder1 
      Left            =   5160
      Top             =   780
      _cx             =   741
      _cy             =   741
   End
   Begin VB.Label lblStatus 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   0
      TabIndex        =   8
      Top             =   2880
      Width           =   5715
   End
   Begin VB.Label Label2 
      Caption         =   "&Encoding:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   720
      Width           =   795
   End
   Begin VB.Label Label1 
      Caption         =   "&File:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   300
      Width           =   495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Function BrowseFile(ByRef strFileName As String, ByRef strFileTitle As String, ByVal bSaveFile As Boolean) As Boolean
    cmnDialog.CancelError = True
    cmnDialog.FileName = ""
    cmnDialog.Filter = "All Files (*.*)|*.*"
    
    BrowseFile = False
    strFileName = ""
    strFileTitle = ""
    
    If bSaveFile Then
        cmnDialog.Flags = cdlOFNPathMustExist + _
                          cdlOFNOverwritePrompt
    Else
        cmnDialog.Flags = cdlOFNPathMustExist + _
                          cdlOFNFileMustExist + _
                          cdlOFNHideReadOnly
    End If
    
    On Error GoTo Finished
    
    If bSaveFile Then
        cmnDialog.Action = 2
    Else
        cmnDialog.Action = 1
    End If
    
    On Error GoTo 0
    strFileName = cmnDialog.FileName
    strFileTitle = cmnDialog.FileTitle
    BrowseFile = True
    
Finished:
    Exit Function
End Function

Private Sub Form_Load()
    comboEncoding.AddItem "Uucode", 0
    comboEncoding.ItemData(0) = fileEncodeUucode
    comboEncoding.AddItem "Base64", 1
    comboEncoding.ItemData(1) = fileEncodeBase64
    comboEncoding.AddItem "Quoted Printable", 2
    comboEncoding.ItemData(2) = fileEncodeQuoted
    comboEncoding.AddItem "yEnc", 3
    comboEncoding.ItemData(3) = fileEncodeYencode
    comboEncoding.ListIndex = 1
End Sub

Private Sub editFileName_GotFocus()
    editFileName.SelStart = 0
    editFileName.SelLength = Len(editFileName.Text)
End Sub

Private Sub cmdBrowse_Click()
    Dim strFileName As String
    Dim strFileTitle As String
    
    If BrowseFile(strFileName, strFileTitle, False) Then
        editFileName.Text = strFileName
    End If
    
    editFileName.SetFocus
End Sub

Private Sub cmdEncode_Click()
    Dim strInputFile As String
    Dim strOutputFile As String
    Dim strFileTitle As String
    Dim nFileSize As Long
    Dim nEncoding As Long
    Dim nError As Long
    
    nEncoding = comboEncoding.ItemData(comboEncoding.ListIndex)
    If chkCompressed.Value = vbChecked Then
        nEncoding = nEncoding Or fileEncodeCompressed
    End If
    
    strInputFile = Trim(editFileName.Text)
    If Len(strInputFile) = 0 Then
        MsgBox "Please enter the name of a file to encode", vbInformation
        editFileName.SetFocus
        Exit Sub
    End If

    If BrowseFile(strOutputFile, strFileTitle, True) = False Then
        Exit Sub
    End If

    nError = FileEncoder1.EncodeFile(strInputFile, strOutputFile, nEncoding)
    If nError <> 0 Then
        MsgBox FileEncoder1.LastErrorString, vbExclamation
        Exit Sub
    End If

    nFileSize = FileLen(strOutputFile)
    lblStatus.Caption = "Created " & strFileTitle & " (" & nFileSize & " bytes)"
    
    MsgBox "Successfully encoded the input file and created" & vbCrLf & _
           strFileTitle & " (" & nFileSize & " bytes)", vbInformation

    editFileName.Text = ""
    editFileName.SetFocus
End Sub

Private Sub cmdDecode_Click()
    Dim strInputFile As String
    Dim strOutputFile As String
    Dim strFileTitle As String
    Dim nFileSize As Long
    Dim nEncoding As Long
    Dim nError As Long
    
    nEncoding = comboEncoding.ItemData(comboEncoding.ListIndex)
    If chkCompressed.Value = vbChecked Then
        nEncoding = nEncoding Or fileDecodeCompressed
    End If
    
    strInputFile = Trim(editFileName.Text)
    If Len(strInputFile) = 0 Then
        MsgBox "Please enter the name of a file to decode", vbInformation
        editFileName.SetFocus
        Exit Sub
    End If

    If BrowseFile(strOutputFile, strFileTitle, True) = False Then
        Exit Sub
    End If

    nError = FileEncoder1.DecodeFile(strInputFile, strOutputFile, nEncoding)
    If nError <> 0 Then
        MsgBox FileEncoder1.LastErrorString, vbExclamation
        Exit Sub
    End If

    nFileSize = FileLen(strOutputFile)
    lblStatus.Caption = "Created " & strFileTitle & " (" & nFileSize & " bytes)"
    
    MsgBox "Successfully encoded the input file and created" & vbCrLf & _
           strFileTitle & " (" & nFileSize & " bytes)", vbInformation

    editFileName.Text = ""
    editFileName.SetFocus
End Sub


