VERSION 5.00
Object = "{8A718D2D-8AF7-4B72-A074-093208112A54}#1.0#0"; "cswsvx10.ocx"
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Math Server Example"
   ClientHeight    =   3015
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   5505
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3015
   ScaleWidth      =   5505
   StartUpPosition =   3  'Windows Default
   Begin InternetServerCtl.InternetServer Server1 
      Left            =   120
      Top             =   2400
      _cx             =   741
      _cy             =   741
   End
   Begin VB.ListBox List1 
      Height          =   1620
      Left            =   105
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   600
      Width           =   5295
   End
   Begin VB.TextBox Text3 
      Height          =   315
      Left            =   4320
      TabIndex        =   5
      Text            =   "100"
      Top             =   120
      Width           =   600
   End
   Begin VB.TextBox Text2 
      Height          =   315
      Left            =   2880
      TabIndex        =   3
      Text            =   "7100"
      Top             =   120
      Width           =   600
   End
   Begin VB.TextBox Text1 
      Height          =   315
      Left            =   840
      TabIndex        =   1
      Text            =   "127.0.0.1"
      Top             =   120
      Width           =   1400
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Start"
      Default         =   -1  'True
      Height          =   375
      Left            =   2122
      TabIndex        =   7
      Top             =   2450
      Width           =   1260
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "Clients:"
      Height          =   195
      Left            =   3720
      TabIndex        =   4
      Top             =   165
      Width           =   510
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Port:"
      Height          =   195
      Left            =   2400
      TabIndex        =   2
      Top             =   165
      Width           =   330
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Address:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   165
      Width           =   615
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketWrench 10.0
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Sub Command1_Click()
    If Server1.State = swServerInactive Then
        Dim strLocalAddress As String
        Dim nLocalPort As Long
        Dim nMaxClients As Long
        Dim nError As Long
        
        strLocalAddress = Trim(Text1.Text)
    
        nLocalPort = Val(Text2.Text)
        If nLocalPort < 1 Or nLocalPort > 65535 Then
            MsgBox "Please specify a valid port number", vbExclamation
            Text2.SetFocus
            Exit Sub
        End If
    
        nMaxClients = Val(Text3.Text)
        If nMaxClients < 0 Then
            MsgBox "Please specify the maximum number of client connections", vbExclamation
            Text3.SetFocus
            Exit Sub
        End If
    
        nError = Server1.Start(strLocalAddress, nLocalPort, 5, nMaxClients, 5)
        If nError > 0 Then
            MsgBox Server1.LastErrorString, vbExclamation
            Exit Sub
        End If
    
        List1.Clear
        Command1.Caption = "Stop"
    Else
        Server1.Stop
        Command1.Caption = "Start"
    End If
End Sub

Private Sub Server1_OnConnect(ByVal Handle As Variant)
    List1.AddItem "Client " & Handle & " connected from " & Server1.ClientAddress & ":" & Server1.ClientPort
    Server1.WriteLine Handle, "OK SocketWrench Math Server Example " & Server1.Version
End Sub

Private Sub Server1_OnDisconnect(ByVal Handle As Variant)
    List1.AddItem "Client " & Handle & " disconnected from the server"
End Sub

Private Sub Server1_OnRead(ByVal Handle As Variant)
    Dim strCommand As String
    
    If Server1.ReadLine(Handle, strCommand) Then
        List1.AddItem "Client " & Handle & " sent command " & Chr(34) & strCommand & Chr(34)
        ParseCommand Handle, strCommand
    End If
End Sub

Private Sub ParseCommand(ByVal Handle As Long, ByVal strCommand As String)
    Dim strParam() As String
    Dim nParams As Long
    Dim dblResult As Double
    Dim nIndex As Long
    
    strParam = Split(Trim(strCommand), " ")
    nParams = UBound(strParam)
    
    ' No command was specified by the client
    If nParams < 0 Then
        Server1.WriteLine Handle, "ERR No command specified"
        Exit Sub
    End If

    On Error GoTo Failed

    Select Case UCase(strParam(0))
    Case "ADD"
        If nParams <> 2 Then GoTo Failed
        dblResult = CDbl(strParam(1)) + CDbl(strParam(2))
        Server1.WriteLine Handle, "OK " + CStr(dblResult)
        
    Case "SUB"
        If nParams <> 2 Then GoTo Failed
        dblResult = CDbl(strParam(1)) - CDbl(strParam(2))
        Server1.WriteLine Handle, "OK " + CStr(dblResult)
        
    Case "MUL"
        If nParams <> 2 Then GoTo Failed
        dblResult = CDbl(strParam(1)) * CDbl(strParam(2))
        Server1.WriteLine Handle, "OK " + CStr(dblResult)
       
    Case "DIV"
        If nParams <> 2 Then GoTo Failed
        dblResult = CDbl(strParam(1)) / CDbl(strParam(2))
        Server1.WriteLine Handle, "OK " + CStr(dblResult)
       
    Case "QUIT"
        Server1.WriteLine Handle, "OK Goodbye"
        Server1.Disconnect Handle
    
    Case Else
        Server1.WriteLine Handle, "ERR Unknown command " + UCase(strParam(0))
    End Select
    Exit Sub
    
Failed:
    Server1.WriteLine Handle, "ERR Invalid command parameter"
    Exit Sub
End Sub
