VERSION 5.00
Object = "{4F4FB8F6-595D-471F-A063-9232D1C668D7}#1.0#0"; "csicmx10.ocx"
Begin VB.Form formMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools Ping Example"
   ClientHeight    =   3885
   ClientLeft      =   2265
   ClientTop       =   1560
   ClientWidth     =   5955
   ForeColor       =   &H80000008&
   Icon            =   "Ping.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3885
   ScaleWidth      =   5955
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin IcmpClientCtl.IcmpClient IcmpClient1 
      Left            =   180
      Top             =   3240
      _cx             =   741
      _cy             =   741
   End
   Begin VB.CheckBox chkBlocking 
      Alignment       =   1  'Right Justify
      Caption         =   "Synchronous"
      Height          =   255
      Left            =   4200
      TabIndex        =   9
      Top             =   120
      Width           =   1455
   End
   Begin VB.TextBox HostName 
      Height          =   285
      Left            =   840
      TabIndex        =   0
      Top             =   120
      Width           =   3255
   End
   Begin VB.CommandButton cmdAction 
      Default         =   -1  'True
      Height          =   375
      Left            =   2370
      TabIndex        =   2
      Top             =   3360
      Width           =   1215
   End
   Begin VB.TextBox PingOutput 
      Height          =   2295
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   480
      Width           =   5655
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "&System:"
      Height          =   195
      Left            =   120
      TabIndex        =   10
      Top             =   150
      Width           =   555
   End
   Begin VB.Label RecvLabel 
      Height          =   195
      Left            =   3480
      TabIndex        =   8
      Top             =   2880
      Width           =   975
   End
   Begin VB.Label LossLabel 
      Height          =   195
      Left            =   5160
      TabIndex        =   3
      Top             =   2880
      Width           =   585
   End
   Begin VB.Label Label5 
      AutoSize        =   -1  'True
      Caption         =   "Loss:"
      Height          =   195
      Left            =   4560
      TabIndex        =   7
      Top             =   2880
      Width           =   375
   End
   Begin VB.Label Label4 
      AutoSize        =   -1  'True
      Caption         =   "Received:"
      Height          =   195
      Left            =   2520
      TabIndex        =   6
      Top             =   2880
      Width           =   735
   End
   Begin VB.Label SendLabel 
      Height          =   195
      Left            =   1440
      TabIndex        =   5
      Top             =   2880
      Width           =   975
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Packets Sent:"
      Height          =   195
      Left            =   120
      TabIndex        =   4
      Top             =   2880
      Width           =   1005
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Sub Form_Load()
    cmdAction.Caption = "Start"
    chkBlocking.Value = vbChecked
    IcmpClient1.Blocking = True
    IcmpClient1.Enabled = False
    IcmpClient1.Timeout = 2000
    IcmpClient1.AutoResolve = False
    SendLabel.Caption = 0
    RecvLabel.Caption = 0
    LossLabel.Caption = 0 & "%"
End Sub

Private Sub cmdAction_Click()
    Dim strHostName As String
    
    strHostName = Trim(HostName.Text)
    If Len(strHostName) = 0 Then
        MsgBox "Please enter a host name or IP address", vbExclamation
        HostName.SetFocus
        Exit Sub
    End If
    
    If IcmpClient1.Enabled Then
        cmdAction.Caption = "Start"
        IcmpClient1.Enabled = False
        IcmpClient1.Reset
        SendLabel.Caption = 0
        RecvLabel.Caption = 0
        LossLabel.Caption = 0 & "%"
    Else
        cmdAction.Caption = "Stop"
        PingOutput.Text = ""
        IcmpClient1.HostName = strHostName
        IcmpClient1.Enabled = True
        IcmpClient1.Interval = 1000
        If chkBlocking.Value = 1 Then
            IcmpClient1.Blocking = True
        Else
            IcmpClient1.Blocking = False
        End If
    End If
End Sub

Private Sub IcmpClient1_OnEcho(ByVal SequenceId As Variant, ByVal RemoteHost As Variant, ByVal PacketSize As Variant)
    Dim Percent As Integer
    
    If IcmpClient1.SendCount > 1 Then
        Percent = 100 - ((IcmpClient1.RecvCount / IcmpClient1.SendCount) * 100)
        LossLabel.Caption = Percent & "%"
    End If
    SendLabel.Caption = IcmpClient1.SendCount
End Sub

Private Sub IcmpClient1_OnError(ByVal ErrorCode As Variant, ByVal Description As Variant)
    Debug.Print "Error " & ErrorCode & " (" & Description & ")"
End Sub

Private Sub IcmpClient1_OnReply(ByVal SequenceId As Variant, ByVal RemoteHost As Variant, ByVal PacketSize As Variant, ByVal ElapsedTime As Variant)
    PingOutput.SelStart = 65535
    PingOutput.SelText = Str$(PacketSize) + " bytes received, icmp_seq=" + Str$(SequenceId) + ", time=" + Str$(ElapsedTime) + " ms" + vbCrLf
    RecvLabel.Caption = IcmpClient1.RecvCount
End Sub

Private Sub IcmpClient1_OnTimeout()
    Debug.Print "Timeout"
End Sub
