VERSION 5.00
Object = "{55BA08D8-B534-486B-A6BA-9B0E78436E57}#1.0#0"; "csnvtx10.ocx"
Object = "{1F367BFD-5A96-4D2D-8CC2-47DDE392C934}#1.0#0"; "cstshx10.ocx"
Begin VB.Form Form1 
   Caption         =   "SocketTools Example"
   ClientHeight    =   3990
   ClientLeft      =   5280
   ClientTop       =   4515
   ClientWidth     =   7875
   ForeColor       =   &H80000008&
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3990
   ScaleWidth      =   7875
   StartUpPosition =   2  'CenterScreen
   Begin SshClientCtl.SshClient SshClient1 
      Left            =   240
      Top             =   3240
      _cx             =   741
      _cy             =   741
   End
   Begin TerminalCtl.Terminal Terminal1 
      Height          =   2655
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   5895
      _cx             =   10398
      _cy             =   4683
      AutoRefresh     =   -1  'True
      AutoSelect      =   0   'False
      AutoWrap        =   0   'False
      BackColor       =   -2147483643
      BoldColor       =   10485760
      Bell            =   0   'False
      Columns         =   80
      Cursor          =   -1  'True
      CursorStyle     =   0
      Enabled         =   -1  'True
      Emulation       =   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Terminal"
         Size            =   9
         Charset         =   255
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   -2147483640
      MousePointer    =   0
      NewLine         =   0
      Rows            =   25
      ScrollBars      =   3
   End
   Begin VB.Menu menuServer 
      Caption         =   "&Server"
      Begin VB.Menu menuConnect 
         Caption         =   "&Connect..."
      End
      Begin VB.Menu menuSeparator1 
         Caption         =   "-"
      End
      Begin VB.Menu menuExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Sub Form_Load()
    ' The emulator Resize event will set width and height
    Terminal1.Top = 0
    Terminal1.Left = 0
End Sub

Private Sub Form_Activate()
    Static bActivated As Boolean
    
    If Not bActivated Then
        ' Set the initial window size to accomodate the full height
        ' and width of the emulator window
        Me.Width = (Terminal1.CellWidth * Screen.TwipsPerPixelX * Terminal1.Columns) + 400
        Me.Height = (Terminal1.CellHeight * Screen.TwipsPerPixelY * Terminal1.Rows) + 1100
        bActivated = True
    End If
    
End Sub

Private Sub Form_Resize()
    ' Adjust the emulator window to the size of the form client area
    Terminal1.Width = Me.ScaleWidth
    Terminal1.Height = Me.ScaleHeight
End Sub

Private Sub menuConnect_Click()
    Dim nError As Long
    
    If SshClient1.State > sshStatusUnused Then
        SshClient1.Disconnect
        menuConnect.Caption = "&Connect..."
        Exit Sub
    End If
    
    Form2.Show vbModal
    If Form2.Canceled Then Exit Sub

    Terminal1.Clear
    SshClient1.Blocking = True
    Form2.Enabled = False
    Form2.MousePointer = vbHourglass
    
    nError = SshClient1.Connect(Form2.HostName, Form2.HostPort, Form2.UserName, Form2.Password)
    If nError <> 0 Then
        Form2.Enabled = True
        Form2.MousePointer = vbDefault
        MsgBox SshClient1.LastErrorString, vbExclamation
        Exit Sub
    End If

    Form2.Enabled = True
    Form2.MousePointer = vbDefault
    menuConnect.Caption = "Disconnect"
    SshClient1.Blocking = False
End Sub

Private Sub menuExit_Click()
    End
End Sub

Private Sub SshClient1_OnRead()
    Dim chBuffer(1024) As Byte
    Dim cbBuffer As Long
    
    Do
        cbBuffer = SshClient1.Read(chBuffer, 1024)
        If cbBuffer > 0 Then Terminal1.Write chBuffer, cbBuffer
    Loop While cbBuffer > 0
End Sub

Private Sub SshClient1_OnDisconnect()
    Dim chBuffer(1024) As Byte
    Dim cbBuffer As Long
    
    ' Read any data that may be in the receive buffers
    Do
        cbBuffer = SshClient1.Read(chBuffer, 1024)
        If cbBuffer > 0 Then Terminal1.Write chBuffer, cbBuffer
    Loop While cbBuffer > 0
    
    SshClient1.Disconnect
    menuConnect.Caption = "&Connect..."
    
    MsgBox "Disconnected from the remote host", vbInformation
End Sub

Private Sub Terminal1_KeyMapped(KeyIndex As Integer, Shift As Integer, KeyString As String)
    SshClient1.SendKey KeyString
End Sub

Private Sub Terminal1_KeyPress(KeyAscii As Integer)
    SshClient1.SendKey KeyAscii
End Sub
