VERSION 5.00
Object = "{5278BD09-BDDB-4941-A4E7-BC06219CC79A}#1.0#0"; "cswskx10.ocx"
Begin VB.Form formMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketWrench UDP Client Example"
   ClientHeight    =   2280
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4275
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2280
   ScaleWidth      =   4275
   StartUpPosition =   2  'CenterScreen
   Begin SocketWrenchCtl.SocketWrench SocketWrench1 
      Left            =   120
      Top             =   1620
      _cx             =   741
      _cy             =   741
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Query"
      Height          =   435
      Left            =   1485
      TabIndex        =   0
      Top             =   1680
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "You should be running the UdpServer example program, which will respond to this broadcast."
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   960
      Width           =   4035
   End
   Begin VB.Label Label1 
      Height          =   675
      Left            =   120
      TabIndex        =   1
      Top             =   180
      Width           =   4035
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketWrench 10.0
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

'
' Configuration values for the UDP client
'
Private Const queryBroadcast = "255.255.255.255" ' Local broadcast address
Private Const queryPort = 8195                   ' Port number
Private Const queryTimeout = 5                   ' Timeout period (seconds)
Private Const queryResponse = 128                ' Maximum datagram size

Private Sub Command1_Click()
    Dim strAddress As String
    Dim nPort As Long
    
    Command1.Enabled = False
    
    If GetServerAddress(strAddress, nPort) Then
        MsgBox "The server requests that you connect to address" & vbCrLf & _
               strAddress & " on port " & nPort, vbInformation, "Success"
    Else
        MsgBox "Unable to determine server address", vbExclamation, "Error"
    End If

    Command1.Enabled = True
End Sub

Private Function GetServerAddress(ByRef strAddress As String, ByRef nPort As Long) As Boolean
    Dim strBuffer As String
    Dim nResult As Long
    Dim nIndex As Long
    Dim nError As Long
    
    GetServerAddress = False
    
    ' Create a UDP socket and specify a broadcast IP address;
    ' note that the Connect method doesn't actually create a
    ' connection like it does with TCP, it simply creates the
    ' socket, binding to the specified address and port number
    nError = SocketWrench1.Connect(queryBroadcast, queryPort, swProtocolUdp, queryTimeout, swOptionBroadcast)
    If nError <> 0 Then Exit Function
    
    ' Create a small datagram that just contains our local IP
    ' address and broadcast it over our local network
    
    strBuffer = SocketWrench1.LocalAddress
    nResult = SocketWrench1.Write(strBuffer, Len(strBuffer))
    If nError = 0 Then
        strBuffer = ""
        
        ' If the server is running, then it will see our broadcast
        ' and respond with the IP address and port number we should
        ' use, otherwise the Read method will timeout
        
        nResult = SocketWrench1.Read(strBuffer, queryResponse)
        If nResult = -1 Then nError = SocketWrench1.LastError
    End If
    
    ' Close the socket by calling the Disconnect method and
    ' return if an error occurred while sending or receiving
    ' the datagram
    
    SocketWrench1.Disconnect
    If nError <> 0 Then Exit Function
    
    ' The response from the server should be a string in the
    ' form of aaa.bbb.ccc.ddd:nnnn specifying both the IP
    ' address in dot-notation and the port number to connect to
    
    nIndex = InStr(strBuffer, ":")
    If nIndex = -1 Then Exit Function
    
    ' Extract the IP address from the response and make sure
    ' that it looks like a valid address
    
    strAddress = Left(strBuffer, nIndex - 1)
    If Not ValidAddress(strAddress) Then Exit Function ' Malformed address
    
    ' Extract the port number from the response and make sure
    ' that it's a valid port number

    nPort = Val(Right(strBuffer, Len(strBuffer) - nIndex))
    If nPort < 1 Or nPort > 65535 Then Exit Function ' Malformed port
    
    GetServerAddress = True
End Function

Private Function ValidAddress(ByRef strAddress As String) As Boolean
    Dim strValue() As String
    Dim strResult As String
    Dim nValue As Long
    Dim nIndex As Long
    
    ValidAddress = False
    
    strValue = Split(strAddress, ".")
    If UBound(strValue) <> 3 Then Exit Function
    
    For nIndex = 0 To 3
        nValue = Val(strValue(nIndex))
        If nValue < 0 Or nValue > 255 Then Exit Function
        strResult = strResult + CStr(nValue)
        If nIndex < 3 Then strResult = strResult + "."
    Next
    
    If strResult <> "0.0.0.0" And strResult <> "255.255.255.255" Then
        strAddress = strResult
        ValidAddress = True
    End If
End Function

Private Sub Form_Load()
    Label1.Caption = "This will broadcast a datagram over the local network " & _
                     "on port " & queryPort & " in an attempt to discover the " & _
                     "IP address and port number for a server."
End Sub
