VERSION 5.00
Object = "{5278BD09-BDDB-4941-A4E7-BC06219CC79A}#1.0#0"; "cswskx10.ocx"
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketWrench UDP Echo Example"
   ClientHeight    =   3840
   ClientLeft      =   5130
   ClientTop       =   2955
   ClientWidth     =   5685
   ForeColor       =   &H80000008&
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3840
   ScaleWidth      =   5685
   Begin SocketWrenchCtl.SocketWrench SocketWrench1 
      Left            =   4980
      Top             =   3360
      _cx             =   741
      _cy             =   741
   End
   Begin VB.CommandButton cmdSend 
      Caption         =   "Send"
      Height          =   375
      Left            =   1515
      TabIndex        =   7
      Top             =   3360
      Width           =   1215
   End
   Begin VB.TextBox editHostPort 
      Height          =   315
      Left            =   4740
      TabIndex        =   3
      Text            =   "7"
      Top             =   240
      Width           =   675
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   375
      Left            =   2955
      TabIndex        =   8
      Top             =   3360
      Width           =   1215
   End
   Begin VB.TextBox editInput 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   330
      Left            =   240
      TabIndex        =   6
      Top             =   2880
      Width           =   5175
   End
   Begin VB.TextBox editHostName 
      Height          =   315
      Left            =   840
      TabIndex        =   1
      Top             =   240
      Width           =   3135
   End
   Begin VB.ListBox listOutput 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1860
      Left            =   240
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   660
      Width           =   5175
   End
   Begin VB.Label labelInput 
      Caption         =   "Enter the text that you wish to be sent to the remote host"
      Height          =   195
      Left            =   240
      TabIndex        =   5
      Top             =   2640
      Width           =   5175
   End
   Begin VB.Label labelHostPort 
      Caption         =   "&Port:"
      Height          =   195
      Left            =   4260
      TabIndex        =   2
      Top             =   300
      Width           =   375
   End
   Begin VB.Label labelHostName 
      BackStyle       =   0  'Transparent
      Caption         =   "&System:"
      Height          =   195
      Left            =   240
      TabIndex        =   0
      Top             =   300
      Width           =   555
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketWrench 10.0
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Const udpBufferSize = 1024&

Private Sub Form_Load()
    '
    ' Initialize the socket control
    '
    SocketWrench1.Blocking = False
    UpdateForm
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    ' If the user changes the host name and we currently have
    ' a socket opened to another system, close it by calling
    ' the Disconnect method

    If SocketWrench1.Handle <> -1 Then SocketWrench1.Disconnect
End Sub

Private Sub editHostName_GotFocus()
    editHostName.SelStart = 0
    editHostName.SelLength = Len(editHostName.Text)
End Sub

Private Sub editHostName_Change()
    
    ' If the user changes the hostname, then close the current
    ' socket; this will force a new datagram socket to be created
    
    If SocketWrench1.Handle <> -1 Then SocketWrench1.Disconnect
    UpdateForm
End Sub

Private Sub editHostPort_GotFocus()
    editHostPort.SelStart = 0
    editHostPort.SelLength = Len(editHostPort.Text)
End Sub

Private Sub editHostPort_Change()
    
    ' If the user changes the port number, then close the current
    ' socket; this will force a new datagram socket to be created
    
    If SocketWrench1.Handle <> -1 Then SocketWrench1.Disconnect
    UpdateForm
End Sub

Private Sub editInput_GotFocus()
    editInput.SelStart = 0
    editInput.SelLength = Len(editInput.Text)
End Sub

Private Sub editInput_Change()
    UpdateForm
End Sub

Private Sub cmdSend_Click()
    Dim strHostName As String
    Dim strMessage As String
    Dim nHostPort As Long
    Dim nError As Long
    Dim nResult As Long
    
    strHostName = Trim(editHostName.Text)
    nHostPort = Val(Trim(editHostPort.Text))
    
    ' Make sure a valid port number has been specified
    If nHostPort < 1 Or nHostPort > 65535 Then
        MsgBox "Please enter a valid port number", vbExclamation
        editHostPort.Text = ""
        editHostPort.SetFocus
        Exit Sub
    End If
    
    ' If the current socket handle is invalid (-1), then create
    ' a new datagram socket
    
    If SocketWrench1.Handle = -1 Then
        nError = SocketWrench1.Connect(strHostName, nHostPort, swProtocolUdp)
        If nError <> 0 Then
            MsgBox SocketWrench1.LastErrorString, vbExclamation
            Exit Sub
        End If
    End If
        
    ' Create the message, limiting to udpBufferSize characters
    ' in length
    
    strMessage = Left(Trim(editInput.Text), udpBufferSize)
    
    nResult = SocketWrench1.Write(strMessage, Len(strMessage))
    If nResult = -1 Then
        MsgBox SocketWrench1.LastErrorString, vbExclamation
        Exit Sub
    End If

    editInput.Text = ""
    editInput.SetFocus
End Sub

Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub SocketWrench1_OnRead()
    Dim strBuffer As String
    Dim nResult As Long
    
    ' Data has arrived, so read it into the specified buffer;
    ' the udpBufferSize value specifies the maximum number of
    ' bytes to read. The method will return the actual number
    ' of bytes read, or -1 if there was an error.
    
    nResult = SocketWrench1.Read(strBuffer, udpBufferSize)
    If nResult = -1 Then
        ' If the error is swConnectionReset, this means that
        ' there's no server on the remote address/port number
        ' specified by the user
        If SocketWrench1.LastError = swErrorConnectionReset Then
            MsgBox "There is no server running on the specified" & vbCrLf & _
                   "host address and/or port number", vbExclamation
            Exit Sub
        Else
            MsgBox SocketWrench1.LastErrorString, vbExclamation
            Exit Sub
        End If
    ElseIf nResult > 0 Then
        ' Data has been successfully read from the socket,
        ' so add it to the listbox
        listOutput.AddItem strBuffer
        listOutput.ListIndex = listOutput.ListCount - 1
        listOutput.Selected(listOutput.ListIndex) = False
    End If
End Sub

Private Sub UpdateForm()
    If Len(Trim(editHostName.Text)) > 0 And Len(Trim(editHostPort.Text)) > 0 Then
        editInput.Enabled = True
        
        If Len(Trim(editInput.Text)) > 0 Then
            cmdSend.Enabled = True
            cmdSend.Default = True
        Else
            cmdSend.Default = False
            cmdSend.Enabled = False
        End If
    Else
        editInput.Enabled = False
        cmdSend.Default = False
        cmdSend.Enabled = False
    End If
End Sub
