VERSION 5.00
Object = "{5278BD09-BDDB-4941-A4E7-BC06219CC79A}#1.0#0"; "cswskx10.ocx"
Begin VB.Form formMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketWrench UDP Server Example"
   ClientHeight    =   4230
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6090
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4230
   ScaleWidth      =   6090
   StartUpPosition =   3  'Windows Default
   Begin SocketWrenchCtl.SocketWrench SocketWrench1 
      Left            =   5460
      Top             =   3660
      _cx             =   741
      _cy             =   741
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   375
      Left            =   3248
      TabIndex        =   6
      Top             =   3720
      Width           =   1155
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start"
      Default         =   -1  'True
      Height          =   375
      Left            =   1688
      TabIndex        =   5
      Top             =   3720
      Width           =   1155
   End
   Begin VB.ListBox listOutput 
      Height          =   2790
      Left            =   120
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   720
      Width           =   5775
   End
   Begin VB.TextBox editPort 
      Height          =   315
      Left            =   5160
      TabIndex        =   3
      Text            =   "5001"
      Top             =   180
      Width           =   735
   End
   Begin VB.ComboBox comboAddress 
      Height          =   315
      Left            =   960
      TabIndex        =   1
      Top             =   180
      Width           =   3195
   End
   Begin VB.Label labelPort 
      Caption         =   "&Port:"
      Height          =   195
      Left            =   4620
      TabIndex        =   2
      Top             =   240
      Width           =   435
   End
   Begin VB.Label labelAddress 
      Caption         =   "Address:"
      Height          =   195
      Left            =   180
      TabIndex        =   0
      Top             =   240
      Width           =   675
   End
End
Attribute VB_Name = "formMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketWrench 10.0
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

'
' Configuration values for the UDP server
'
Private Const srvLocalAddress = "0.0.0.0"
Private Const srvLocalPort = 8195
Private Const srvBufferSize = 128

Private Sub Form_Load()
    Dim nIndex As Long
    
    ' Initialize the comboAddress control with the available
    ' addresses that the socket can be bound to
    
    If SocketWrench1.AdapterCount = 0 Then
        comboAddress.ListIndex = -1
    Else
        For nIndex = 0 To SocketWrench1.AdapterCount - 1
            comboAddress.AddItem SocketWrench1.AdapterAddress(nIndex)
        Next
        comboAddress.ListIndex = 0
    End If
End Sub

Private Sub editPort_GotFocus()
    editPort.SelStart = 0
    editPort.SelLength = Len(editPort.Text)
End Sub

Private Sub cmdStart_Click()
    If SocketWrench1.Handle = -1 Then
        Dim strAddress As String
        Dim nPort As Long
        Dim nError As Long
                
        strAddress = Trim(comboAddress.Text)
        If Not ValidAddress(strAddress) Then
            MsgBox "Please specify a valid IP address", vbExclamation
            comboAddress.ListIndex = 0
            comboAddress.SetFocus
            Exit Sub
        End If
        
        nPort = Val(Trim(editPort.Text))
        If nPort < 1 Or nPort > 65535 Then
            MsgBox "Please specify a valid port number", vbExclamation
            editPort.Text = ""
            editPort.SetFocus
            Exit Sub
        End If
    
        ' Use the Connect method to create the socket. For a UDP datagram
        ' server, you're not actually "connecting" to a system, but rather
        ' creating a socket and binding it to an address
        
        SocketWrench1.Blocking = False
        nError = SocketWrench1.Bind(srvLocalAddress, srvLocalPort, swProtocolUdp)
        If nError <> 0 Then
            MsgBox SocketWrench1.LastErrorString, vbExclamation
            Exit Sub
        End If
    
        listOutput.Clear
        cmdStart.Caption = "Stop"
        comboAddress.Enabled = False
        editPort.Enabled = False
    Else
        SocketWrench1.Disconnect
        listOutput.Clear
        cmdStart.Caption = "Start"
        comboAddress.Enabled = True
        editPort.Enabled = True
    End If
End Sub

Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub SocketWrench1_OnRead()
    Dim strAddress As String
    Dim nPort As Long
    Dim strBuffer As String
    Dim nResult As Long
    
    ' Read the datagram sent to us by the remote host
    ' and discard it, we only need their IP address and
    ' port number
    
    nResult = SocketWrench1.Read(strBuffer, srvBufferSize, , strAddress, nPort)
    If nResult = -1 Then
        Output "Error " & SocketWrench1.LastError & ": " & SocketWrench1.LastErrorString
        Exit Sub
    End If
    
    ' Send a datagram back to the peer with the IP address
    ' and port number we have specified; this uses the WriteEx
    ' method since it allows us to easily specify the remote
    ' address and port
    
    strBuffer = Trim(comboAddress.Text) + ":" + Trim(editPort.Text)
    
    nResult = SocketWrench1.Write(strBuffer, Len(strBuffer), , strAddress, nPort)
    If nResult = -1 Then
        Output "Error " & SocketWrench1.LastError & ": " & SocketWrench1.LastErrorString
        Exit Sub
    End If
    
    Output "Sent address " & strBuffer & " to " & strAddress & " on port " & nPort
    
End Sub

Private Sub Output(ByVal strMessage As String)
    listOutput.AddItem strMessage
    listOutput.ListIndex = listOutput.ListCount - 1
    listOutput.Selected(listOutput.ListIndex) = False
End Sub

Private Function ValidAddress(ByRef strAddress As String) As Boolean
    Dim strValue() As String
    Dim strResult As String
    Dim nValue As Long
    Dim nIndex As Long
    
    ValidAddress = False
    
    strValue = Split(strAddress, ".")
    If UBound(strValue) <> 3 Then Exit Function
    
    For nIndex = 0 To 3
        nValue = Val(strValue(nIndex))
        If nValue < 0 Or nValue > 255 Then Exit Function
        strResult = strResult + CStr(nValue)
        If nIndex < 3 Then strResult = strResult + "."
    Next
    
    If strResult <> "0.0.0.0" And strResult <> "255.255.255.255" Then
        strAddress = strResult
        ValidAddress = True
    End If
End Function
