VERSION 5.00
Object = "{6A8A6528-B259-4AF7-AAAD-3531E0A35B18}#1.0#0"; "cswebx10.ocx"
Begin VB.Form MainForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools Web Storage"
   ClientHeight    =   5460
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   9150
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5460
   ScaleWidth      =   9150
   StartUpPosition =   3  'Windows Default
   Begin WebStorageCtl.WebStorage WebStorage1 
      Left            =   8520
      Top             =   4080
      _cx             =   741
      _cy             =   741
   End
   Begin VB.CommandButton cmdDelete 
      Caption         =   "Delete"
      Height          =   495
      Left            =   7800
      TabIndex        =   9
      Top             =   2520
      Width           =   1215
   End
   Begin VB.ListBox listLabels 
      Height          =   4155
      Left            =   120
      Sorted          =   -1  'True
      TabIndex        =   4
      Top             =   960
      Width           =   7455
   End
   Begin VB.TextBox txtLabelName 
      Height          =   315
      Left            =   1320
      TabIndex        =   3
      Text            =   ""
      Top             =   480
      Width           =   6255
   End
   Begin VB.TextBox txtLocalFile 
      Height          =   315
      Left            =   1320
      TabIndex        =   1
      Text            =   ""
      Top             =   120
      Width           =   6255
   End
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Height          =   495
      Left            =   7800
      TabIndex        =   10
      Top             =   3120
      Width           =   1215
   End
   Begin VB.CommandButton cmdDownload 
      Caption         =   "Download"
      Height          =   495
      Left            =   7800
      TabIndex        =   8
      Top             =   1920
      Width           =   1215
   End
   Begin VB.CommandButton cmdUpload 
      Caption         =   "Upload"
      Height          =   495
      Left            =   7800
      TabIndex        =   7
      Top             =   1320
      Width           =   1215
   End
   Begin VB.CommandButton cmdRefresh 
      Caption         =   "Refresh"
      Height          =   495
      Left            =   7800
      TabIndex        =   6
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "Open"
      Height          =   495
      Left            =   7800
      TabIndex        =   5
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label lblInfo 
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   5160
      Width           =   7455
   End
   Begin VB.Label lbLabelName 
      Caption         =   "Label Name:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   525
      Width           =   975
   End
   Begin VB.Label lblLocalFile 
      Caption         =   "Local File:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   855
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub UpdateForm(Optional ByVal bEnable As Boolean = True)
    If WebStorage1.IsOpened Then
        cmdOpen.Enabled = False
        cmdRefresh.Enabled = bEnable
        cmdUpload.Enabled = bEnable
        cmdDownload.Enabled = bEnable
        cmdDelete.Enabled = bEnable
        cmdClose.Enabled = bEnable
    Else
        cmdOpen.Enabled = True
        cmdRefresh.Enabled = False
        cmdUpload.Enabled = False
        cmdDownload.Enabled = False
        cmdDelete.Enabled = False
        cmdClose.Enabled = False
        listLabels.Clear
    End If
End Sub

Private Sub Form_Load()
    cmdOpen.Enabled = True
    cmdRefresh.Enabled = False
    cmdUpload.Enabled = False
    cmdDownload.Enabled = False
    cmdClose.Enabled = False
    listLabels.Clear
End Sub

Private Sub cmdClose_Click()
    WebStorage1.Close
    UpdateForm False
End Sub

Private Sub cmdDelete_Click()
    If WebStorage1.Delete(txtLabelName.Text) Then
        lblInfo.Caption = "Deleted " & txtLabelName.Text & " from container"
        MsgBox "Deleted " & txtLabelName.Text, vbInformation
        cmdRefresh_Click
    Else
        MsgBox WebStorage1.LastErrorString, vbExclamation
    End If
End Sub

Private Sub cmdDownload_Click()
    UpdateForm False
    
    If WebStorage1.GetFile(txtLocalFile.Text, txtLabelName.Text) Then
        lblInfo.Caption = "Downloaded " & txtLabelName.Text & " from container"
        MsgBox "Downloaded " & txtLabelName.Text, vbInformation
    Else
        MsgBox WebStorage1.LastErrorString, vbExclamation
    End If
    
    UpdateForm True
End Sub

Private Sub cmdOpen_Click()
    If WebStorage1.Open() Then
        UpdateForm True
        cmdRefresh_Click
    Else
        MsgBox WebStorage1.LastErrorString, vbExclamation
        Exit Sub
    End If
End Sub

Private Sub cmdRefresh_Click()
    Dim nObjects As Long
    
    listLabels.Clear
    nObjects = 0
    UpdateForm False
    
    If WebStorage1.FindFirst() Then
        Do
            nObjects = nObjects + 1
            listLabels.AddItem WebStorage1.ObjectLabel
        Loop Until Not WebStorage1.FindNext()
    End If
    
    UpdateForm True
    lblInfo.Caption = "Found " & nObjects & " objects in current container"
End Sub

Private Sub cmdUpload_Click()
    UpdateForm False
    
    If WebStorage1.PutFile(txtLocalFile.Text, txtLabelName.Text) Then
        lblInfo.Caption = "Uploaded " & txtLabelName.Text & " in container"
        MsgBox "Uploaded " & txtLabelName.Text, vbInformation
        cmdRefresh_Click
    Else
        MsgBox WebStorage1.LastErrorString, vbExclamation
    End If
    
    UpdateForm True
End Sub

Private Sub listLabels_Click()
    txtLabelName.Text = listLabels.List(listLabels.ListIndex)
End Sub
