VERSION 5.00
Object = "{4B73D882-8C2A-4619-B38D-122B74E0DB10}#1.0#0"; "cswhox10.ocx"
Begin VB.Form formWhois 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SocketTools Whois Example"
   ClientHeight    =   5055
   ClientLeft      =   3990
   ClientTop       =   2805
   ClientWidth     =   8025
   ForeColor       =   &H80000008&
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5055
   ScaleWidth      =   8025
   StartUpPosition =   2  'CenterScreen
   Begin WhoisClientCtl.WhoisClient WhoisClient1 
      Left            =   4800
      Top             =   4560
      _cx             =   741
      _cy             =   741
   End
   Begin VB.ComboBox comboSearch 
      Height          =   315
      Left            =   1200
      Style           =   2  'Dropdown List
      TabIndex        =   7
      Top             =   810
      Width           =   2175
   End
   Begin VB.TextBox editKeyword 
      Height          =   285
      Left            =   1200
      TabIndex        =   5
      Text            =   "sockettools.com"
      Top             =   450
      Width           =   6675
   End
   Begin VB.TextBox editHostName 
      Height          =   285
      Left            =   1200
      TabIndex        =   2
      Text            =   "whois.networksolutions.com"
      Top             =   90
      Width           =   6675
   End
   Begin VB.TextBox viewOutput 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3225
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   1
      Top             =   1230
      Width           =   7755
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "Query"
      Default         =   -1  'True
      Height          =   375
      Left            =   3420
      TabIndex        =   0
      Top             =   4560
      Width           =   1275
   End
   Begin VB.Label staticSearch 
      Caption         =   "Search:"
      Height          =   195
      Left            =   120
      TabIndex        =   6
      Top             =   870
      Width           =   735
   End
   Begin VB.Label staticKeyword 
      AutoSize        =   -1  'True
      Caption         =   "Domain Name:"
      Height          =   195
      Left            =   120
      TabIndex        =   4
      Top             =   480
      Width           =   1050
   End
   Begin VB.Label staticHostName 
      AutoSize        =   -1  'True
      Caption         =   "Server:"
      Height          =   195
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   510
   End
End
Attribute VB_Name = "formWhois"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SocketTools 10 Build 1468
' Copyright 2023 Catalyst Development Corporation
' All rights reserved
'
' This file is licensed to you pursuant to the terms of the
' product license agreement included with the original software,
' and is protected by copyright law and international treaties.
' Unauthorized reproduction or distribution may result in severe
' criminal penalties.
'
Option Explicit

Private Sub Form_Load()
    comboSearch.AddItem "Any Record", 0
    comboSearch.AddItem "Handle", 1
    comboSearch.AddItem "Name", 2
    comboSearch.AddItem "Mailbox", 3
    comboSearch.ListIndex = 0
End Sub

Private Sub cmdAction_Click()
    Dim nError As Long
    
    WhoisClient1.Blocking = False
    WhoisClient1.HostName = Trim$(editHostName.Text)
    WhoisClient1.RemotePort = whoisPortDefault
    WhoisClient1.Keyword = Trim$(editKeyword.Text)
    WhoisClient1.SearchType = comboSearch.ListIndex

    nError = WhoisClient1.Connect()
    If nError <> 0 Then
        MsgBox WhoisClient1.LastErrorString, vbExclamation
        Exit Sub
    End If
    
    cmdAction.Enabled = False
    Exit Sub
End Sub

Private Sub WhoisClient1_OnConnect()
    viewOutput.Enabled = True
    viewOutput.Text = ""
End Sub

Private Sub WhoisClient1_OnDisconnect()
    WhoisClient1.Disconnect
    cmdAction.Enabled = True
End Sub

Private Sub WhoisClient1_OnRead()
    Dim strBuffer As String, strLine As String
    Dim nLength As Long, nPos As Long
    
    Do
        nLength = WhoisClient1.Read(strBuffer, 1024)
        If nLength < 1 Then Exit Do
        
        ' Because the output from a UNIX server will typically only
        ' terminate lines of text with a linefeed, we need to convert
        ' that to a carriage-return/linefeed pair so that it is
        ' displayed correctly in the text box
        
        Do While nLength > 0
            nPos = InStr(strBuffer, vbLf)
            If nPos = 0 Then
                strLine = strBuffer
                nLength = 0
            Else
                strLine = Left(strBuffer, nPos - 1)
                strBuffer = Right(strBuffer, nLength - nPos)
                nLength = Len(strBuffer)
                
                If Len(strLine) > 0 And Right(strLine, 1) = vbCr Then
                    strLine = strLine + vbLf
                Else
                    strLine = strLine + vbCrLf
                End If
            End If
        
            viewOutput.SelStart = Len(viewOutput.Text)
            viewOutput.SelText = strLine
        Loop
    Loop
End Sub

